
function DataCompliance(){
	/**Variables*/
	var _this=this;
	var Selector = {};
	
	var lmsConnected=false;
	var scormApi;
	var bookmark;
	var suspendData="";
	var lessonStatus="incomplete";
	var lmsScore = "";
	var scoreRaw="";
	var scoreMin=0;
	var scoreMax=100;
	var langObj;
	var successStatus = "unknown";	
	var entryState="";
	var lessonMode="";
	var studentName="Student Name";
	
	_this.start = function (_obj) {
		Selector={
			BOOKMARK : "cmi.core.lesson_location",
			LESSONSTATUS : "cmi.core.lesson_status",
			SUSPENDDATA : "cmi.suspend_data",
			ENTRYSTATE : "cmi.core.entry",
			LESSON_MODE : "cmi.core.lesson_mode",
			SESSIONTIME : "cmi.core.session_time",
			SCORE : "cmi.core.score.raw",
			STUDENT_NAME:"cmi.core.student_name",	
			SCORE_MAX:"cmi.core.score.max",
			SCORE_MIN:"cmi.core.score.min",
			EXIT:"cmi.core.exit",
			PREFER_LANG:"cmi.student_preference.language",
			USER_RESPONCE:".student_response",
			TIME:".time"
			
		};
		Selector = $.extend(Selector, _obj);
		initTemplate();
	}
	
	
	//---
	function initTemplate(){
	
	/**complianceType
		 *  0: STANDALONE/No tracking
		 *  1: SCORM1.2
		 *  2: SCORM2004
		 */
		scormApi = pipwerks.SCORM;
		scormApi.version="1.2";
		if(APP.configObj.tracking.complianceType == "2"){
			scormApi.version="2004";
			Selector.BOOKMARK = "cmi.location";
			Selector.LESSONSTATUS = "cmi.completion_status";
			Selector.SUSPENDDATA = "cmi.suspend_data";
			Selector.ENTRYSTATE = "cmi.entry";
			Selector.LESSON_MODE = "cmi.mode";
			Selector.SESSIONTIME = "cmi.session_time";
			Selector.SCORE="cmi.score.raw";
			Selector.STUDENT_NAME="cmi.learner_name";
			Selector.SCORE_MAX="cmi.score.max";
			Selector.SCORE_MIN="cmi.score.min";	
			Selector.EXIT="cmi.exit";	
			Selector.PREFER_LANG="cmi.learner_preference.language";
			Selector.SCORE_SCALED="cmi.score.scaled";
			Selector.SUCCESS_STATUS="cmi.success_status";
			Selector.USER_RESPONCE=".learner_response";
			Selector.TIME=".timestamp";
		}
		if(APP.configObj.tracking.complianceType=="0"){
			lmsConnected=false;
		}else{
			lmsConnected = scormApi.init();
		}
		if (lmsConnected) {
			getLMSData();
			
		} else {			
			startCourse();
		}		
	}
	
	_this.getStudentName=function(){
		return studentName;
	}
	_this.getLangObj=function(){
		return langObj;
	}
	_this.getSuspendData=function(){
		return suspendData;
	}
	_this.getBookMark=function(){
		return bookmark;
	}
	_this.setBookMark=function(val){		
		bookmark = val;		
	}
	
	function getLMSData(){
		var langObj=scormApi.get(Selector.PREFER_LANG);
		
		entryState = scormApi.get(Selector.ENTRYSTATE);
		lessonMode = scormApi.get(Selector.LESSON_MODE);
		suspendData = scormApi.get(Selector.SUSPENDDATA);
		
		bookmark = scormApi.get(Selector.BOOKMARK);			
		
		lessonStatus=scormApi.get(Selector.LESSONSTATUS);
		if(APP.configObj.tracking.complianceType == "2"){
			successStatus=	scormApi.get(Selector.SUCCESS_STATUS);
		}
		scoreRaw = scormApi.get(Selector.SCORE);
		lmsScore = scoreRaw;
		
		studentName = scormApi.get(Selector.STUDENT_NAME);
		
		if(studentName != null && studentName.toString() != ""){
			if(studentName.indexOf(",") != -1){
				var nameArr = studentName.split(",");
				studentName = nameArr[1] + " " + nameArr[0];
			}	
		}
		
		if(lessonStatus==null){
			lessonStatus="incomplete";
		}		
		if(lessonStatus=="completed" || lessonStatus=="passed" || lessonStatus=="failed" ){
			//lessonStatus=lessonStatus;
		}else{
			lessonStatus="incomplete";
		}	
		
		//scormApi.set(Selector.SCORE_MIN, scoreMin);
		//scormApi.set(Selector.SCORE_MAX, scoreMax);
		
		startCourse();
		//--
		APP.commonFunObj.startLmsInterval();		
		//--
	}	

    _this.resetScormData=function() {
        lessonStatus = "incomplete";		
		successStatus = "unknown";
		scoreRaw = "";		
    }
	_this.updateUserData = function(){		
		//console.log('updateUserData...')
		//--
		APP.commonFunObj.stopLmsInterval();		
		//--
		if (APP.courseDataObj.isAllPageCompleted()) {	
			lessonStatus = "completed";
		} else {
			lessonStatus = "incomplete";
		}
		
		if (scoreRaw.toString() != "" && scoreRaw != null) {					
			if (scoreRaw >= 80) {
				successStatus = "passed";
				lessonStatus = "completed";	
			}else{
				successStatus = "failed";
				lessonStatus = "completed";	
			}
		}else{
			successStatus='unknown';
		}

		setLMSData();		
	}

	_this.closeCourse = function(){			
		if (!APP.courseClosed && lmsConnected && scormApi != null)
		{				
			_this.updateUserData();
			//--
			APP.commonFunObj.stopLmsInterval();		
			//--
			APP.commonFunObj.insertDelay(200);
			var timeSpent = getSessionTime(APP.currentTime.getTime());
			scormApi.set(Selector.SESSIONTIME, timeSpent);
			//custom edit for client lms
			
			scormApi.set(Selector.EXIT, "suspend");
			
			var commit=scormApi.save();
			if(!commit){
				APP.commonFunObj.showNetworkFailPop();
			}	
			scormApi.quit();
			lmsConnected = false;
			APP.courseClosed = true;
		}	
			
	}
	_this.callCommit = function(){
		//console.log('callCommit...')
		APP.commonFunObj.checkConnection(myCallBack);
		if (lmsConnected && scormApi != null) {
			var commit=scormApi.save();
			if(!commit){
				APP.commonFunObj.showNetworkFailPop();
			}
		}
	}
	function setLMSData(){		
		APP.commonFunObj.checkConnection(myCallBack);
		APP.courseDataObj.sendDataToLocalStorage();
		if (lmsConnected && scormApi != null) {	
			scormApi.set(Selector.PREFER_LANG, APP.configObj.language.lang);
			
			var currBookmark = APP.courseBookmark;
			bookmark = currBookmark;
			scormApi.set(Selector.BOOKMARK, currBookmark);
			
			var currSusData=APP.courseDataObj.updateSuspendData();
			scormApi.set(Selector.SUSPENDDATA, currSusData);
			
			scormApi.set(Selector.LESSONSTATUS, lessonStatus);
			
			if (scoreRaw.toString() != "" && scoreRaw!=null) {
				if(APP.configObj.tracking.complianceType == "2"){
					var perScore=scoreRaw / 100;
					scormApi.set(Selector.SCORE, scoreRaw);
					scormApi.set(Selector.SCORE_SCALED, perScore);
				}else{
					scormApi.set(Selector.SCORE, scoreRaw);
				}
			}
			if(APP.configObj.tracking.complianceType == "2"){
				scormApi.set(Selector.SUCCESS_STATUS, successStatus);	
			}
			var commit=scormApi.save();
			if(!commit){
				APP.commonFunObj.showNetworkFailPop();
			}	
			//--
			APP.commonFunObj.startLmsInterval();		
			//--
		}  
		
	}
				
	function getSessionTime(curr) {
		var dtm = new Date();
		var initalTime=curr;
		var n = dtm.getTime() - initalTime;
		if(APP.configObj.tracking.complianceType == "2"){
			return ConvertMilliSecondsIntoSCORM2004Time(n);
		}else{
			return MillisecondsToCMIDuration(n);
		}
	}

	function MillisecondsToCMIDuration(LessonDuration) {
		var hr = "000" + Math.floor(LessonDuration / (60 * 60 * 1000));
		var temp = (LessonDuration - (hr * 60 * 60 * 1000));
		var min = "0" + Math.floor(temp / (60 * 1000));
		var sec = temp - (min * 60 * 1000);
		temp = temp - (sec * 1000);
		var ms = "0" + Math.floor(temp / 1000);
		sec = "0" + Math.floor(sec / 1000);
		var LessonDurationFormat = hr.substr(hr.length - 4) + ":" + min.substr(min.length - 2) + ":" + sec.substr(sec.length - 2) + "." + ms.substr(ms.length - 2);
		return LessonDurationFormat;
	}

	function ConvertMilliSecondsIntoSCORM2004Time(intTotalMilliseconds){	
		var ScormTime = "";
		var HundredthsOfASecond;
		var Seconds;
		var Minutes;
		var Hours;
		var Days;
		var Months;
		var Years;	
		var HUNDREDTHS_PER_SECOND = 100;
		var HUNDREDTHS_PER_MINUTE = HUNDREDTHS_PER_SECOND * 60;
		var HUNDREDTHS_PER_HOUR   = HUNDREDTHS_PER_MINUTE * 60;
		var HUNDREDTHS_PER_DAY    = HUNDREDTHS_PER_HOUR * 24;
		var HUNDREDTHS_PER_MONTH  = HUNDREDTHS_PER_DAY * (((365 * 4) + 1) / 48);
		var HUNDREDTHS_PER_YEAR   = HUNDREDTHS_PER_MONTH * 12;    	
		HundredthsOfASecond = Math.floor(intTotalMilliseconds / 10);    	
		Years = Math.floor(HundredthsOfASecond / HUNDREDTHS_PER_YEAR);
		HundredthsOfASecond -= (Years * HUNDREDTHS_PER_YEAR);    	
		Months = Math.floor(HundredthsOfASecond / HUNDREDTHS_PER_MONTH);
		HundredthsOfASecond -= (Months * HUNDREDTHS_PER_MONTH);    	
		Days = Math.floor(HundredthsOfASecond / HUNDREDTHS_PER_DAY);
		HundredthsOfASecond -= (Days * HUNDREDTHS_PER_DAY);
		Hours = Math.floor(HundredthsOfASecond / HUNDREDTHS_PER_HOUR);
		HundredthsOfASecond -= (Hours * HUNDREDTHS_PER_HOUR);
		Minutes = Math.floor(HundredthsOfASecond / HUNDREDTHS_PER_MINUTE);
		HundredthsOfASecond -= (Minutes * HUNDREDTHS_PER_MINUTE);
		Seconds = Math.floor(HundredthsOfASecond / HUNDREDTHS_PER_SECOND);
		HundredthsOfASecond -= (Seconds * HUNDREDTHS_PER_SECOND);
		if (Years > 0) {
			ScormTime += Years + "Y";
		}
		if (Months > 0){
			ScormTime += Months + "M";
		}
		if (Days > 0){
			ScormTime += Days + "D";
		}
		if ((HundredthsOfASecond + Seconds + Minutes + Hours) > 0 ){
			ScormTime += "T";
			if (Hours > 0){
				ScormTime += Hours + "H";
			}    		
			if (Minutes > 0){
				ScormTime += Minutes + "M";
			}    		
			if ((HundredthsOfASecond + Seconds) > 0){
				ScormTime += Seconds;
				
				if (HundredthsOfASecond > 0){
					ScormTime += "." + HundredthsOfASecond;
				}    			
				ScormTime += "S";
			}    		
		}    	
		if (ScormTime == ""){
			ScormTime = "0S";
		}    	
		ScormTime = "P" + ScormTime;
		return ScormTime;
	}
	
	
}

