function Event() {
	var _this = this;
	_this.ON_PAGE_LOADING = "pageLoading";
	_this.ON_PAGE_LOADCOMPLETE = "pageLoadingCompleted";
	_this.ON_PAGE_COMPLETE = "pageCompleted";
	_this.ON_NAVIGATIONXML_LOADING = "navigationLoading";
	_this.ON_NAVIGATIONXML_LOADCOMPLETE = "navigationLoadingCompleted";
	_this.ON_GLOBALXML_LOADING = "globalxmlLoading";
	_this.ON_GLOBALXML_LOADCOMPLETE = "globalxmlLoadingCompleted";
	_this.ON_SCREEN_RESIZE = "screenResize";
	_this.ON_PAGE_UPDATE = "pageUpdated";
	_this.ON_SCORE_UPDATE = "scoreUpdated";
	_this.blinkExitButton = blinkExitButton;
	if (APP.systemDetectorObj.deviceType == 'desktop') {
		$('#app-body').on('mouseenter', 'a', function () {
			if ($(this).hasClass('disabled')) {
				$(this).removeClass('hover');
				return false
			}
			$(this).addClass('hover')
		});
		$('#app-body').on('mouseleave', 'a', function () {
			$(this).removeClass('hover');
		})
	}
	$(document).bind(_this.ON_NAVIGATIONXML_LOADING, function (e) {
		//console.log("navigation xml loading...");
		APP.preloaderObj.show();
	});
	$(document).bind(_this.ON_NAVIGATIONXML_LOADCOMPLETE, function (e) {
		//console.log("navigation xml loaded...");        
		//APP.preloaderObj.hide();
		APP.globalXmlsObj.loadGlobalXML();		
	});
	$(document).bind(_this.ON_GLOBALXML_LOADING, function (e) {
		//console.log("global xml loading...");
		APP.preloaderObj.show();
	});
	$(document).bind(_this.ON_GLOBALXML_LOADCOMPLETE, function (e) {
		//console.log("global xml loaded...");
		APP.preloaderObj.hide();
		APP.dataComObj.start();		
	});
	$(document).bind(_this.ON_PAGE_LOADING, function (e) {
		//console.log("page loading...");
		removeBlinkNextButton();
		removeBlinkExitButton();
		APP.preloaderObj.show();
		$('.page-counter').removeClass('black');	
		APP.courseBookmark=APP.navData.moduleId+"_"+APP.navData.subModuleId+"_"+APP.navData.pageId;
	});
	$(document).bind(_this.ON_PAGE_LOADCOMPLETE, function (e) {
		
		//sections-panel
		APP.preloaderObj.hide();
		
		updateAppLayout();
		updateNavigationButtons();
		updatePageCounter();
		
		APP.dataComObj.updateUserData();
		$(document).trigger(APP.eventObj.ON_PAGE_UPDATE);
	});
	$(document).bind(_this.ON_PAGE_COMPLETE, function (e) {
		//console.log("page complete...");
		checkNextButton();
		blinkNextButton();
		
	});
	
	$(window).on('resize', function () {
		$(document).trigger(_this.ON_SCREEN_RESIZE);
	});
	$(window).on("orientationchange", function () {
		$("html, body").scrollTop(0);
		$(document).trigger(_this.ON_SCREEN_RESIZE);
	});
	$(document).bind(_this.ON_SCREEN_RESIZE, function (e) {
		updateAppLayout();
		updateNavigationButtons();
		updatePageCounter();
	});
	$(document).bind(_this.ON_PAGE_UPDATE, function (e) {
		//for motivation button
		var selGenQue =0;
		var obj = APP.interviewQuesObj.generalQues;
		if(obj!=null && obj.length){						
			for(var i=0; i<obj.length; i++){
				if(obj[i].pick == true){
					selGenQue++;
				}				
			}
		}
		var txt = APP.commonFunObj.getNumberTxt(selGenQue, true) +" "+ APP.globalXmlsObj.screenDataXML.sectionsScreen[0].questionAddedTxt[0].Text;
		$('.sections-panel').find('.section_0').find('.status').html(txt);
		
		//for technical button
		var selTyeQue =0;
		var obj = APP.interviewQuesObj.typedQues;
		if(obj!=null && obj.length){						
			for(var i=0; i<obj.length; i++){
				if(obj[i].txt !=null && obj[i].txt!=''){
					selTyeQue++;
				}				
			}		
		}
		var txt = APP.commonFunObj.getNumberTxt(selTyeQue, true) +" "+ APP.globalXmlsObj.screenDataXML.sectionsScreen[0].questionAddedTxt[0].Text;
		$('.sections-panel').find('.section_2').find('.status').html(txt);
		
		//-- for competency button
		var SelSkiQue =0;
		var skillObj = APP.interviewQuesObj.selectedSkill;	
		if(skillObj!=null && skillObj.length){				
			for(var k=0; k<skillObj.length; k++){	
				for(var l=0; l<skillObj[k].length; l++){	
					if(skillObj[k][l].pick == true){				
						var QObj = skillObj[k][l].pickQ;
						if(QObj!=null && QObj.length){
							for(var p=0; p<QObj.length; p++){					
								if(QObj[p].pick == true){
									SelSkiQue++;						
								}
							}
						}					
					}
				}
			}
		}
		var typedSkillObj = APP.interviewQuesObj.typedSkill;
		if(typedSkillObj!=null && typedSkillObj.length){						
			for(var i=0; i<typedSkillObj.length; i++){
				if(typedSkillObj[i].title !=null && typedSkillObj[i].title !=''){
					var QObj = typedSkillObj[i].addedQ;
					if(QObj!=null && QObj.length){
						for(var p=0; p<QObj.length; p++){					
							if(QObj[p].txt !=null && QObj[p].txt!=''){
								SelSkiQue++;
							}
						}
					}
				}
								
			}		
		}
		//console.log('curr: '+curr)
		var txt = APP.commonFunObj.getNumberTxt(SelSkiQue, true) +" "+ APP.globalXmlsObj.screenDataXML.sectionsScreen[0].questionAddedTxt[0].Text;
		$('.sections-panel').find('.section_1').find('.status').html(txt);
		
		//for addition information button
		var sTxt = APP.globalXmlsObj.screenDataXML.sectionsScreen[0].noneTxt[0].Text;
		if(APP.interviewQuesObj.additionalInfo){
			var obj = APP.interviewQuesObj.additionalInfo.txt;			
			if(obj !=null && obj!=''){
				sTxt = APP.globalXmlsObj.screenDataXML.sectionsScreen[0].addedTxt[0].Text;
			}			
		}		
		$('.sections-panel').find('.section_3').find('.status').html(sTxt);
		
		//--for genetate Button
		if(selGenQue > 0 || selTyeQue > 0 || SelSkiQue > 0){
			$('.access-screen').removeClass('disabled');
			$('.download-data-btn').removeClass('disabled');
			$('.download-doc-btn').removeClass('disabled');
		}else{
			$('.access-screen').addClass('disabled');
			$('.download-data-btn').addClass('disabled');
			$('.download-doc-btn').addClass('disabled');
		}
	});
	
	$(document).on('click','.btn.exit', function (e) {
		APP.commonFunObj.showExitPop();
	});
	$(document).on('click','.btn-back', function (e) {
		if($(this).hasClass('disabled')){return false;}
		APP.navigationObj.loadBackPage();
	});
	$(document).on('click','.btn-next', function (e) {
		if($(this).hasClass('disabled')){return false;}
		APP.navigationObj.loadNextPage();
	});
	$(document).on('click','.btn-next-step', function (e) {
		if($(this).hasClass('disabled')){return false;}
		APP.navigationObj.loadNextPage();
	});
	$(document).on('click','.role-btn', function (e) {
		if($(this).hasClass('disabled')){return false;}	
		
		if($(this).attr('checked')){			
			return false;
		}
		if(APP.interviewQuesObj.selectedRole != null){
			APP.interviewQuesObj.selectedRole.role = $(this).data('role');
			APP.interviewQuesObj.selectedRole.inx = $(this).data('inx');
		}else{
			APP.interviewQuesObj.selectedRole = {role:$(this).data('role'), inx:$(this).data('inx')}
		}
		$('#candidate-detail').find('.role-btn').prop('checked', false);
		$('#candidate-detail').find('.role-btn').removeAttr('checked');
		$(this).prop('checked', true);
		$(this).attr('checked', 'checked');
		//--reset skill obj
		//APP.interviewQuesObj.selectedSkill=[];
		$(document).trigger(APP.eventObj.ON_PAGE_UPDATE);
		APP.navigationObj.loadPage();
	});
	$(document).on('click','.btn_section', function (e) {
		if($(this).hasClass('disabled')){return false;}
		var jump = $(this).data('jump');
		if(jump !=null){
			APP.navData.moduleId = parseInt(jump.split('_')[0]);
			APP.navData.subModuleId = parseInt(jump.split('_')[1]);
			APP.navData.pageId = parseInt(jump.split('_')[2]);
			APP.navigationObj.loadPage();
			APP.commonFunObj.scrollToElement($('#sections-panel'), false, 'top')
		}
		
	});
	$(document).on('change','#file-input', function (e) {
		let _this = $(this);
		if(_this.hasClass('disabled')){return false;}
		let val = _this.val();
		if(val != null || val != ''){
			$('.bookmark-pop').find('.load-file-btn').removeClass('disabled');
		}else{
			$('.bookmark-pop').find('.load-file-btn').addClass('disabled');
		}

	});

	

	function saveTextAsFile(textToWrite, fileNameToSaveAs, fileType) {
		let textFileAsBlob = new Blob([textToWrite], { type: fileType });
		let downloadLink = document.createElement('a');
		downloadLink.download = fileNameToSaveAs;
		downloadLink.innerHTML = 'Download File';
	
		if (window.webkitURL != null) {
			downloadLink.href = window.webkitURL.createObjectURL(
				textFileAsBlob
			);
		} else {
			downloadLink.href = window.URL.createObjectURL(textFileAsBlob);
			downloadLink.style.display = 'none';
			document.body.appendChild(downloadLink);
		}
	
		downloadLink.click();
		
	}
	
	$(document).on('click','.download-data-btn', function (e) {
		if($(this).hasClass('disabled')){return false;}		
		/* const file = new File(['foo'], 'new-note.txt', {
			type: 'text/plain',
		  })		  
		const link = document.createElement('a')
		const url = URL.createObjectURL(file)
		
		link.href = url
		link.download = file.name
		document.body.appendChild(link)
		link.click()
		
		document.body.removeChild(link)
		window.URL.revokeObjectURL(url) */
		let currSusData = JSON.stringify(APP.courseDataObj.updateSuspendData());
		let t= APP.interviewQuesObj.candidateDetail.position || '';
		let fileName = prompt("Please enter file name", t);
		if(fileName != null){
			saveTextAsFile(currSusData, fileName+'.data', 'text/plain');
		}		
	});
	$(document).on('click','.download-doc-btn', function (e) {
		if($(this).hasClass('disabled')){return false;}		
		APP.navigationObj.openDownloadForm('doc');
	});

	$(document).on('click','.access-screen', function (e) {
		if($(this).hasClass('disabled')){return false;}		
		APP.navigationObj.openDownloadForm('live');
	});
	$(document).on('click','#candidate-com-btn', function (e) {
		if($(this).hasClass('disabled')){return false;}			
		APP.navigationObj.openComparisonForm();
	});
	$(document).on('click','#reset-data-btn', function (e) {
		if($(this).hasClass('disabled')){return false;}	
		//APP.commonFunObj.showResetDataPop();
		if(!APP.globalMessageOpen){
			APP.commonFunObj.showBookmarkPop();
		}
	});
	var evt="keydown keyup blur";
	if(APP.systemDetectorObj.browserName == 'ie'){
		evt= "keypress keyup blur"
	}
	$('#app-body').on(evt, '.candidate-detail .input-box', function (event) {
		var val= $.trim($(this).val());
		var id = $(this).data('id');	
		
		if(id =='candidate-name'){
			APP.interviewQuesObj.candidateDetail.name=val;
		}
		if(id =='candidate-position'){
			APP.interviewQuesObj.candidateDetail.position=val;
		}
		APP.dataComObj.updateUserData();
	});
	_this.updateSectionButtons= function(){
		$('#sections-panel').find('.btn_section').removeClass('selected');
		var currBtn = $('#sections-panel').find('.section_'+APP.navData.pageId);
		
		if(currBtn.length){			
			currBtn.addClass('selected');
		}
	}
	function updateNavigationButtons() {
		
		var winWd = window.innerWidth;
		var obj=APP.navData.currentPageObj;
		$('.header').show();
		//--section selctor
		_this.updateSectionButtons();
		
		//--
		if (APP.navData.pageId == 0) {
			//$('.btn-back').addClass('disabled');			
			//$('.btn-back').hide();
			$('.btn-back').addClass('visibility-hidden');
		}else{
			//$('.btn-back').removeClass('disabled');
			//$('.btn-back').show();
			$('.btn-back').removeClass('visibility-hidden');
		}
		checkNextButton();
	}
	function checkNextButton(){
		if(APP.globalXmlsObj.navigationXML == null){return false;}
		var totPages=APP.globalXmlsObj.navigationXML.module[APP.navData.moduleId].module[APP.navData.subModuleId].page.length - 1;
		if (APP.navData.pageId >= totPages) {
			//$('.btn-next').addClass('disabled');
			//$('.btn-next').hide();
			$('.btn-next').addClass('visibility-hidden');
		}else{
			//$('.btn-next').removeClass('disabled');
			//$('.btn-next').show();
			$('.btn-next').removeClass('visibility-hidden');
			var currPageMandatory=APP.navData.currentPageObj.mandatory || "";
			var isComplete=APP.courseDataObj.isPageComplete();
			if(currPageMandatory == "true" && !isComplete){
				//$('.btn-next').hide();
				$('.btn-next').addClass('visibility-hidden');
			}
		}
	}
	function blinkNextButton(){
		if($('.btn-next').length){
			if(!($('.btn-next').hasClass('visibility-hidden'))){
				$('.btn-next').addClass('animated shake_small');
			}			
		}
	}
	function removeBlinkNextButton(){
		if($('.btn-next').length){
			$('.btn-next').removeClass('animated shake_small');
		}
	}
	function blinkExitButton(){
		if($('.btn.exit').length){
			$('.btn.exit').addClass('animated pulse');					
		}
	}
	function removeBlinkExitButton(){
		if($('.btn.exit').length){
			$('.btn.exit').removeClass('animated pulse');					
		}
	}
	function updatePageCounter(){
		if(APP.globalXmlsObj.navigationXML == null){return false;}
		var winWd = window.innerWidth;
		var totPages=(APP.globalXmlsObj.navigationXML.module[APP.navData.moduleId].module[APP.navData.subModuleId].page.length) - 1;
		var str ="";
		if(winWd <= APP.configObj.breakPoint.mobile){
			str = APP.navData.pageId +'/'+ totPages;
		}else{
			str = "Page " + APP.navData.pageId +'/'+ totPages;
		}
		$('.page-counter .txt').html(str);
	}
	function updateAppLayout() {
		
		
	}
}