var APP = APP || {};
APP.navData = {
	moduleId: 0,
	subModuleId: 0,
	pageId: 0,
	currentPageObj:{},
	currentPageTemplate:{}
}

APP.courseBookmark="";

APP.userLanguageChanged = false;
APP.globalMessageOpen = false;

APP.beforeUnloadFired = false;
APP.courseClosed=false;
APP.winWillClose=false;

APP.finalScoreArr=[];

APP.currentTime;
APP.interviewQuesObj={
	candidateDetail:{},
	selectedSkill:[],
	typedSkill:[],
	typedQues:[],
	generalQues:[],
	additionalInfo:{},
	selectedRole:{role:'pm', inx:0}
}
var winWd = window.screen.availWidth;
var winHt = window.screen.availHeight;
window.moveTo(0, 0);
window.resizeTo(winWd, winHt);

$(document).ready(function () {
	/* $(document).bind("contextmenu", function (e) {
		e.preventDefault();
	}); */
	APP.configObj = new Configuration();
	APP.systemDetectorObj = new SystemDetector();	
	APP.systemDetectorObj.init();	
	
	if(APP.configObj.system.toBeChecked){
		var sys = new SystemValidator();
		sys.start();	
	}else{
		loadFramework();
	}
});

function loadFramework(){	
	$('body').html(getFrameworkHtml());
	var brNameVerClass=APP.systemDetectorObj.browserName+"_"+parseInt(APP.systemDetectorObj.browserVersion);
	$('body').addClass(APP.systemDetectorObj.browserName).addClass(APP.systemDetectorObj.deviceType).addClass(brNameVerClass);
	
	APP.preloaderObj = new Preloader();
	APP.preloaderObj.show();
	
	APP.commonFunObj = new Common();
	APP.GetHtmlStructObj = new GetHtmlStructure();
	
	APP.commonFunObj.preloadImages(
		"framework/images/blank.png",
		"framework/images/logo.svg",
		"framework/images/logo_short.svg",
		"content/images/intro/image1.jpg",
		"content/images/intro/image2.jpg",
		"content/images/intro/image3.jpg",
		"content/images/intro/image4.jpg",
		"content/images/intro/image5.jpg",
		"content/images/intro/image6.jpg"
	);
		
	APP.loadFilesObj = new LoadFiles();
	APP.globalXmlsObj = new GlobalXmlData();
	APP.navigationObj = new Navigation();
	APP.eventObj = new Event();
	APP.courseDataObj = new CourseData();
	APP.dataComObj = new DataCompliance();
	
	loadXmls();
}
function loadXmls(){
	APP.currentTime = new Date();
	APP.globalXmlsObj.loadNavigationXML();
}
function startCourse(){
	
	updateCourse();	
}
function updateCourse(){
	//--
	var t='<strong>'+APP.globalXmlsObj.screenDataXML.courseTitle[0].Text+'</strong>'
	$('.header .course-title').html(t);
	var menuBtnTxt = APP.globalXmlsObj.screenDataXML.commonText[0].menuBtn[0].title[0].Text;
	var candidateComBtnTxt = APP.globalXmlsObj.screenDataXML.commonText[0].candidateComBtn[0].title[0].Text;
	var resetDataTxt = APP.globalXmlsObj.screenDataXML.commonText[0].resetDataBtn[0].title[0].Text;
	$('#menu-btn').attr('title',menuBtnTxt);
	$('#candidate-com-btn').html(candidateComBtnTxt);
	$('#reset-data-btn').html(resetDataTxt);
	
	
	
	//---
	$('#candidate-detail').html(APP.GetHtmlStructObj.getCandidateScreen());
	$('#sections-panel').html(APP.GetHtmlStructObj.getSectionScreen());
	var swiper = new Swiper('#candidate-detail .swiper-container', {
		grabCursor: false,
		autoHeight: false,
		speed: 1000,
		keyboard: false,
		loop:true,
		autoplay: {
			delay: 5000,
			disableOnInteraction: false
		}     
    });

	if(!APP.globalMessageOpen){
		APP.commonFunObj.showBookmarkPop();
	}

	//--logic for upadate previous data
	/* var bmObj='';
	if(APP.commonFunObj.isScorm()){
		var prevData=APP.dataComObj.getSuspendData();	
		APP.courseDataObj.createCourseData(prevData);
		
		var langObj=APP.dataComObj.getLangObj();
		if(langObj!=null && langObj!=""){
			APP.configObj.language.lang=langObj;
		}
		bmObj=APP.dataComObj.getBookMark();
	}else if (typeof(Storage) !== "undefined") {
		//for local storage
		APP.courseDataObj.retriveDataFromLocalStorage();
		bmObj = APP.courseBookmark;
	}else{
		APP.courseDataObj.createCourseData('');		
	}
	if(bmObj!=null && bmObj!=""){
		if(bmObj.indexOf('_') != -1){
			var t=bmObj.split('_');
			APP.navData.moduleId=parseInt(t[0]);
			APP.navData.subModuleId=parseInt(t[1]);
			APP.navData.pageId=parseInt(t[2]);
		}
		if(!APP.globalMessageOpen){
			APP.commonFunObj.showBookmarkPop();
		}
	}else{
		if(!APP.globalMessageOpen){
			APP.navigationObj.loadPage();
		}
	} */
	
}
//--for candidate data
function updateCandidateData() {
	$('#candidate-detail').find('.candidate-name').val('');
	$('#candidate-detail').find('.candidate-position').val('');
	if(APP.interviewQuesObj.candidateDetail){
		if(APP.interviewQuesObj.candidateDetail.name !=null){
			_nameTxt = APP.interviewQuesObj.candidateDetail.name;
			$('#candidate-detail').find('.candidate-name').val(_nameTxt);
		}
		if(APP.interviewQuesObj.candidateDetail.position !=null){
			_posTxt = APP.interviewQuesObj.candidateDetail.position;
			$('#candidate-detail').find('.candidate-position').val(_posTxt);
		}
	}
	if(APP.interviewQuesObj.selectedRole){
		var selectedRoll = APP.interviewQuesObj.selectedRole.role;
		if(selectedRoll != null){
			$('#candidate-detail').find('.role-btn').prop('checked', false);
			$('#candidate-detail').find('.role-btn').removeAttr('checked');
			$('#candidate-detail').find('.role-btn[data-role='+selectedRoll+']').prop('checked', true);
			$('#candidate-detail').find('.role-btn[data-role='+selectedRoll+']').attr('checked', 'checked');
		}
	}	
}

function getFrameworkHtml() {
	var str = "";
	/* 1 */
	str += '<div id="app-body" class="app-body">'
	str += '<div class="preloader-parent" ></div>';
	str += '<div class="alpha-bg"></div>';	
	str += '<div class="gb-pop exit-pop"></div>';
	str += '<div class="gb-pop api-fail-pop"></div>';
	str += '<div class="gb-pop network-fail-pop"></div>';
	str += '<div class="gb-pop bookmark-pop"></div>';
	str += '<div class="gb-pop reset-data-pop"></div>';

	str += '<div class="header">';
		str += '<div class="full-width display-table">';
			str += '<div class="course-logo display-cell">';
				str += '<img src="framework/images/logo.svg" alt="Logo" />';
			str += '</div>';
			str += '<p class="course-title display-cell"><strong></strong></p>';
			str += '<div class="dropdown menu-dropdown-panel">';
			str += '<div class="btn-panel menu-btn-panel display-cell dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">';
				str += '<a id="menu-btn" class="btn menu-btn " id="dropdownMenu"  title="Menu">';
                 str+='<span class="line"></span>';               
                 str+='<span class="line"></span>';               
                 str+='<span class="line"></span>';             
                    
				str += '</a>';
			str += '</div>';
			str += '<ul class="main-dd dropdown-menu dropdown-menu-right" aria-labelledby="dropdownMenu">';
				str += '<li><a tabindex="-1" id="candidate-com-btn" class="dp-option-btn">Candidates Comparison</a></li>';
				str += '<li role="presentation" class="divider"></li>';
				str += '<li><a tabindex="-1" id="reset-data-btn" class="dp-option-btn">Reset Data</a></li>';				
            str += '</ul>';
			str += '</div>';
		str += '</div>';
	str += '</div>';
		
	str += '<div id="candidate-detail" class="candidate-detail page hide-on-print"></div>';
	str += '<div id="sections-panel" class="sections-panel page hide-on-print"></div>';
	str += '<div id="page-container" class="page-container"></div>';
	
	
	str += '<div id="footer-box" class="footer-box"></div>';
	str += '<div id="net-con"></div>';
	/* 1 */
	str += '</div>'
	return str;
}
function myCallBack(result){
	 if(result == false){ 
		 APP.commonFunObj.showNetworkFailPop();
	}
}
function onBeforeUnloaded(e){
	if(!APP.winWillClose){
		 e.preventDefault();
		  // Chrome requires returnValue to be set
		  var str="Are you sure you wish to exit?";
		  if(APP.globalXmlsObj){
			  str=APP.globalXmlsObj.screenDataXML.exitPopText[0].text[0].Text;
		  }
		  e.returnValue = str;
		
	}
}
function winUnloaded(e){
	if(APP.configObj!=null){
		var compType=APP.configObj.tracking.complianceType;
		if((compType!= null && compType.toString() != "0") && APP.dataComObj != null){
			APP.dataComObj.closeCourse();
		}	
	}
}	