function Navigation() {
	var _this = this;
	_this.loadNextPage = function () {
		totPages=APP.globalXmlsObj.navigationXML.module[APP.navData.moduleId].module[APP.navData.subModuleId].page.length;
		if (APP.navData.pageId < (totPages - 1)) {
			APP.navData.pageId++;
		}
		_this.loadPage();
	}
	_this.loadBackPage = function () {
		if (APP.navData.pageId > 0) {
			APP.navData.pageId--;
		}
		_this.loadPage();
	}
	_this.loadResultPage=function(){
		var currObj=_this.getPageIdByType("result");
		APP.navData.moduleId= currObj.modId;
		APP.navData.subModuleId= currObj.subModId;
		APP.navData.pageId= currObj.pageId;
		_this.loadPage();
	} 
	_this.getPageIdByType=function(_type){
		var modObj=APP.globalXmlsObj.navigationXML.module;
		var obj={};	
		for(var i=0; i<modObj.length; i++){
			var subModObj=APP.globalXmlsObj.navigationXML.module[i].module;
			for(var j=0; j<subModObj.length; j++){
				var pageObj=APP.globalXmlsObj.navigationXML.module[i].module[j].page;
				for(var k=0; k<pageObj.length; k++){
					if(pageObj[k].pageType==_type){
						return obj={
							modId:i,
							subModId:j,
							pageId:k
						}
						break;
					}
					
				}
			}
		}
	}
	_this.loadPage = function () {
		APP.commonFunObj.removeVideoMediaElement();
		updateNavCurrentPageObj();
		$(document).trigger(APP.eventObj.ON_PAGE_LOADING);
		$('#page-container').html('');
		//$("html, body").scrollTop(0);
		
		var pageType = APP.navData.currentPageObj.pageType.toLowerCase();
		switch(pageType){
			case "intro":
				APP.navData.currentPageTemplate = new NormalScreen();
				APP.navData.currentPageTemplate.start({
					xmlNode: APP.globalXmlsObj.screenDataXML.introScreen[0],
					type:'intro-screen'
				})
			break;	               
			case "skillselection":
				APP.navData.currentPageTemplate = new SkillSelection();
			break;
			case "skillquestions":
				APP.navData.currentPageTemplate = new SkillQuestions();
			break;
			case "techquestions":
				APP.navData.currentPageTemplate = new TypeQuestions();
			break;
			case "generalquestions":
				APP.navData.currentPageTemplate = new GeneralQuestions();
			break;
			case "additionalinfoscreen":
				APP.navData.currentPageTemplate = new AddInfoScreen();
			break;
			case "scorescreen":
				APP.navData.currentPageTemplate = new NormalScreen();
				APP.navData.currentPageTemplate.start({
					xmlNode: APP.globalXmlsObj.screenDataXML.scoreScreen[0],
					type:'score-screen'
				})
			break;
			case "allquescreen":
				APP.navData.currentPageTemplate = new FinalQuesForm();
				APP.navData.currentPageTemplate.start({	
					xmlNode: APP.globalXmlsObj.screenDataXML.finalQuesFormScreen[0],
					type:'final-ques-screen',
					mode:'static'
				})
			break;
			case "allassessquescreen":
				APP.navData.currentPageTemplate = new FinalQuesForm();
				APP.navData.currentPageTemplate.start({	
					xmlNode: APP.globalXmlsObj.screenDataXML.finalQuesFormScreen[0],
					type:'final-ques-screen',
					mode:'editable'
				})
			break;
		}
	}
	_this.openDownloadForm = function(_mode){
		let mode = _mode || '';
		var _path="download_form.html?mode="+mode+'&r=' + Math.random();
		var wWd = screen.availWidth;
		//var wWd = 1024;
		var wHt = screen.availHeight;  
		
		var win = window.open(_path, 'download_form', 'width=' + wWd + ',height=' + wHt + ',scrollbars=1,screenX=0,screenY=0,resizable=yes,status=no');
		win.focus();	
	}
	_this.openComparisonForm = function(){
		var _path="candidates_comparison.html?r=" + Math.random();
		//var wWd = screen.availWidth;
		var wWd = 1024;
		var wHt = screen.availHeight;  
		
		var win = window.open(_path, 'Comparison_form', 'width=' + wWd + ',height=' + wHt + ',scrollbars=1,screenX=0,screenY=0,resizable=yes,status=no');
		win.focus();	
	}

	function updateNavCurrentPageObj() {
		APP.navData.currentPageObj = APP.globalXmlsObj.navigationXML.module[APP.navData.moduleId].module[APP.navData.subModuleId].page[APP.navData.pageId];
	}

	function getModuleCount() {
		return APP.globalXmlsObj.navigationXML.module.length;
	}

	function getSubModuleCount(_modId) {
		if (APP.globalXmlsObj.navigationXML.module[_modId].module != null) {
			return APP.globalXmlsObj.navigationXML.module[_modId].module.length;
		} else {
			return null;
		}
	}

	function getPageCount(_modId, _subModId) {
		if (_modId >= getModuleCount()) {
			return null;
		}
		return APP.globalXmlsObj.navigationXML.module[_modId].module[_subModId].page.length;
	}
}